Index: git/arch/arm/common/sharpsl_pm.c
===================================================================
--- git.orig/arch/arm/common/sharpsl_pm.c	2006-04-13 09:42:46.000000000 +0100
+++ git/arch/arm/common/sharpsl_pm.c	2006-04-20 21:54:31.000000000 +0100
@@ -525,6 +525,7 @@
 		dev_dbg(sharpsl_pm.dev, "User alarm at: %08x\n",RTAR);
 	} else {
 		dev_dbg(sharpsl_pm.dev, "No alarms set.\n");
+		RTAR = 0;
 	}
 
 	pxa_pm_enter(state);
@@ -647,6 +648,11 @@
 
 	dev_dbg(sharpsl_pm.dev, "Charge Mode: %d\n", sharpsl_pm.charge_mode);
 
+	if(!(sharpsl_pm.machinfo->read_devdata(SHARPSL_STATUS_ACIN))) {
+		dev_dbg(sharpsl_pm.dev, "Offline Charger: Called but no AC\n");
+		return 1;
+	}
+
 	if (sharpsl_pm.charge_mode == CHRG_OFF) {
 		dev_dbg(sharpsl_pm.dev, "Offline Charger: Step 1\n");
 
